#include "stdafx.h"
#include "ModuleManager.h"
#include "ModuleInstance.h"

CModuleManager::CModuleManager()
{

}

bool	CModuleManager::GetInfo(ProgModuleApi2::SUnitInfo*s)
{
	if((s->m_StructSize<sizeof(ProgModuleApi2::SUnitInfo))||(s->m_ApiVersion<ProgModuleApi2::API_VERSION))
	{
		return false;
	}

	//s->m_pConfigFilename;	ini file for store all settings of module
	s->m_Version=100; //1.00
	s->m_ApiVersionRequest=203; //  2.03
	s->m_ApiVersion=ProgModuleApi2::API_VERSION;
	wcscpy_s(s->m_Author,_countof(s->m_Author),L"Prog");	

	s->m_SubDeviceCount=1;
	s->m_SubDeviceIDArray[0]=0;

	return true;
}


bool	CModuleManager::GetModuleInfo(ProgModuleApi2::SModuleInfo*mi)
{
	if(mi->m_StructSize<sizeof(ProgModuleApi2::SModuleInfo)) return false;

	wcscpy_s(mi->m_Name,_countof(mi->m_Name),L"Demo module");
	mi->m_dwCaps= ProgModuleApi2::EModuleCaps::OPTIONS;
		
	return true;

}

ProgModuleApi2::IBaseApi2Module*	CModuleManager::CreateModule(ProgModuleApi2::SCreateModuleParams*p)
{
	return new CModuleInstance(p->m_pEngineApi);
}

void	CModuleManager::DestroyModule(ProgModuleApi2::IBaseApi2Module*p)
{
	delete (CModuleInstance*)p;
}

//pmodule = 0 for access to settings without start modu
bool  CModuleManager::ShowOptionsDialog(DWORD subID,ProgModuleApi2::IBaseApi2Module*pmodule,HWND hParent)
{
	if(pmodule==0)
	{
		MessageBox(hParent,L"Test",L"Module demo",0);
	}
	else
	{
		((CModuleInstance*)pmodule)->ShowOptionsDialog(hParent);
	}

	return true;
}

bool  CModuleManager::SetDialogSettings(DWORD subID,ProgModuleApi2::IBaseApi2Module*pmodule,ProgDvbEngine::Dialogs::SBase*)
{
	return false;
}


bool  CModuleManager::GetDialogSettings(DWORD subID,ProgModuleApi2::IBaseApi2Module*pmodule,ProgDvbEngine::Dialogs::SBase*)
{
	return false;
}

const wchar_t* CModuleManager::GetLastError()
{
	return 0;
}


///////////////////////////////////////////////////////////////////////////////////

CModuleManager g_ModuleManager;

namespace ProgModuleApi2
{
	ProgModuleApi2::PUnit	__declspec(dllexport) __cdecl ProgModuleApi2_GetModuleUnit()
	{
		return &g_ModuleManager;
	}
};
